SystemOrganization addCategory: #MemoryMentor!
SystemOrganization addCategory: #'MemoryMentor-Tests'!

!ByteArray methodsFor: '*MemoryMentor' stamp: 'RL 5/3/2013 11:38:58.14'!
intAt: index
	| word |
	<primitive: 165>
	word := self basicAt: index.
	word < 16r3FFFFFFF ifTrue:[^word]. "Avoid LargeInteger computations"
	^word >= 16r80000000	"Negative?!!"
		ifTrue:["word - 16r100000000"
				(word bitInvert32 + 1) negated]
		ifFalse:[word]! !

!ByteArray methodsFor: '*MemoryMentor' stamp: 'RL 5/3/2013 11:44:13.346'!
intAt: index put: anInteger
	| word |
	<primitive: 166>
	anInteger < 0
		ifTrue:[anInteger < -16r80000000 ifTrue: [self error: anInteger asString , ' out of range'].
				"word := 16r100000000 + anInteger"
				word := (anInteger + 1) negated bitInvert32]
		ifFalse:[anInteger > 16r7FFFFFFF ifTrue: [self error: anInteger asString , ' out of range'].
				word := anInteger].
	self  basicAt: index put: word.
	^anInteger! !

Morph subclass: #MMMemoryCellMorph
	instanceVariableNames: 'cell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor'!

!MMMemoryCellMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:43:55.154'!
for: cell
	^ self new
		setupCell: cell;
		yourself! !

!MMMemoryCellMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 10:38:44.236'!
createByte: i
	|morph width height|
	width := (TextStyle default defaultFont widthOf: $0) * 8.
	height := TextStyle default defaultFont height + 5.
	morph := BorderedMorph new
		extent: width @ height;
		color: (Color gray: 0.9);
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		listCentering: #center;
		yourself.
	morph addMorph: (StringMorph new
		contents: (cell byteAt: i) asString;
		yourself).
	^ morph! !

!MMMemoryCellMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:08:57.808'!
initialize 
	super initialize.
	self extent: 140@18.
	self color: Color white.
	self
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		listCentering: #left! !

!MMMemoryCellMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 10:35:32.908'!
setupCell: aCell
	| width height stringMorph |
	width := 0.
	height := 0.
	cell := aCell.
	1 to: 4 do: [ :i | | morph |
		morph := self createByte: 4-i.
		height := height max: morph height.
		width := width + morph width.
		self addMorph: morph.
	].
	stringMorph := (StringMorph new contents: '0x', (cell address printStringBase: 16); yourself).
	width := width + stringMorph width.
	height := height max: stringMorph height.
	self addMorph: stringMorph.
	self extent: width @ height.! !

Morph subclass: #MMMemoryMorph
	instanceVariableNames: 'memory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor'!

!MMMemoryMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:14:59.09'!
for: memory
	^ self new
		setupMemory: memory;
		yourself! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:08:08.976'!
initialize
	super initialize.
	self
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #bottomToTop;
		listCentering: #center
! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:02:34.86'!
memory: aMemory
	memory := aMemory! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 10:35:59.398'!
setupMemory: aMemory
	| height width |
	height := 0.
	width := 0.
	memory := aMemory.
	memory cellsDo: [ :cell | | cellMorph |
		cellMorph := MMMemoryCellMorph  for: cell.
		height := height + cellMorph height.
		width := width max: cellMorph width.
		self addMorph: cellMorph.
	].
	self extent: width @ height.! !

Object subclass: #MMMemory
	instanceVariableNames: 'startAddress memory cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor'!

!MMMemory class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:11:14.556'!
withStartAddress: startAddress cellSize: size
	^ self new
		initializeWithStartAddress: startAddress cellSize: size;
		yourself! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:31:02.124'!
at: address putByte: byte
	memory byteAt: (self indexForAddress: address) put: byte! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:30:41.608'!
at: address putByteArray: byteArray
	byteArray withIndexDo: [ :byte :index |
		self at: address+index-1 putByte: (byteArray at: index)
	]! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:32:11.56'!
at: address putInt: int
	memory intAt: (self indexForAddress: address) put: int! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:25:05.046'!
byteAt: adress
	 ^ memory at: (self indexForAddress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 13:04:27.336'!
byteSize
	^ memory size! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:14:26.12'!
cellAtAddress: address
	^ cells at: (self cellIndexForAddress: address)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:13:45.782'!
cellIndexForAddress: address
	^ ((address roundDownTo: 4) - startAddress)/4 + 1! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:06:46.236'!
cellSize
	^ cells size! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:24:07.742'!
cellsDo: aBlock
	^ cells do: aBlock! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:12:46.656'!
indexForAddress: address
	^ address - startAddress + 1! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:19:00.408'!
initializeWithStartAddress: adress cellSize: size
	startAddress := adress.
	memory := ByteArray new: size*4.
	cells := OrderedCollection new.
	1 to: size do: [ :i |
		cells add: (MMMemoryCell at: (4*(i-1) + startAddress) in: self)
	]! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:32:31.124'!
intAt: address
	 ^ memory intAt: (self indexForAddress: address)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:12:09.978'!
startAddress
	^ startAddress! !

Object subclass: #MMMemoryCell
	instanceVariableNames: 'address memory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor'!

!MMMemoryCell class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:15:46.536'!
at: address in: memory
	 ^ self new
		initializeWithAddress: address andMemory: memory;
		yourself! !

!MMMemoryCell class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 12:41:51.122'!
size
	 ^ 4! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:15:11.996'!
address
	^ address! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:22:27.266'!
byteAt: index
	^ memory byteAt: address + index! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:15:28.346'!
initializeWithAddress: anAddress andMemory: aMemory
	address := anAddress.
	memory := aMemory! !

TestCase subclass: #MMMemoryCellTest
	instanceVariableNames: 'memory startAddress size cell address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Tests'!

!MMMemoryCellTest methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 14:30:15.308'!
setUp
	startAddress := 16r1000.
	address := startAddress + 40.
	size := 100.
	memory := MMMemory withStartAddress: startAddress cellSize: size.
	
	cell := MMMemoryCell at: address in: memory! !

!MMMemoryCellTest methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 14:15:58.392'!
testInitialization
	self assert: [ cell address == address ]! !

TestCase subclass: #MMMemoryTest
	instanceVariableNames: 'startAddress size memory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Tests'!

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 14:25:35.734'!
setUp
	startAddress := 4096.
	size := 25.
	memory := MMMemory withStartAddress: startAddress cellSize: size! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 14:29:05.224'!
testCellAccess
	self shouldnt: [ memory cellAtAddress: startAddress + 8 ] raise: Exception.
	self assert: [ (memory cellAtAddress: startAddress + 8) address == (startAddress + 8) ].
	
	self shouldnt: [ memory cellAtAddress: startAddress + 40 ] raise: Exception.
	self assert: [ (memory cellAtAddress: startAddress + 40) address == (startAddress + 40) ].
	
	self shouldnt: [ memory cellAtAddress: startAddress + 96 ] raise: Exception.
	self assert: [ (memory cellAtAddress: startAddress + 96) address == (startAddress + 96) ].
	
	self should: [ memory cellAtAddress: startAddress - 4 ] raise: Exception.
	
	self should: [ memory cellAtAddress: startAddress + 100 ] raise: Exception
! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 15:07:50.83'!
testCellIteration
	| cellIndex |
	cellIndex := 0.
	
	memory cellsDo: [ :cell |
		self assert: [ cell address == (4*cellIndex + startAddress) ].
		cellIndex := cellIndex + 1
	].
	
	self assert: [ cellIndex == size ]! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 15:09:19.864'!
testInitialization
	self assert: [ memory startAddress == startAddress ].
	self assert: [ memory cellSize == size ].
	self assert: [ memory byteSize == (size * MMMemoryCell size)]! !
